# coding: utf-8

"""
    Smstools API

    The SMS Gateway API for smstools provides a robust and easy-to-integrate solution for sending and receiving SMS messages programmatically. It enables developers to integrate text messaging capabilities into their applications, websites, and software, offering features such as sending single or bulk SMS, managing contacts and groups, receiving inbound messages, and accessing delivery reports. This API facilitates various communication needs, from marketing campaigns to CRM integrations and automated alerts. Please note that this API description is independently created and not affiliated with smstools.com. Official documentation at: https://www.smstools.com/en/sms-gateway-api/

    The version of the OpenAPI document: 0.0.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr

class SubaccountResponse(BaseModel):
    """
    SubaccountResponse
    """
    id: Optional[StrictStr] = Field(None, alias="ID")
    username: Optional[StrictStr] = None
    email: Optional[StrictStr] = None
    memo: Optional[StrictStr] = None
    amount_of_logins: Optional[StrictInt] = None
    __properties = ["ID", "username", "email", "memo", "amount_of_logins"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SubaccountResponse:
        """Create an instance of SubaccountResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # set to None if email (nullable) is None
        # and __fields_set__ contains the field
        if self.email is None and "email" in self.__fields_set__:
            _dict['email'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SubaccountResponse:
        """Create an instance of SubaccountResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SubaccountResponse.parse_obj(obj)

        _obj = SubaccountResponse.parse_obj({
            "id": obj.get("ID"),
            "username": obj.get("username"),
            "email": obj.get("email"),
            "memo": obj.get("memo"),
            "amount_of_logins": obj.get("amount_of_logins")
        })
        return _obj


